function _sliceIterator(arr, i) {
	var _arr = [];
	var _n = true;
	var _d = false;
	var _e = undefined;
	try {
		for (
			var _i = arr[Symbol.iterator](), _s;
			!(_n = (_s = _i.next()).done);
			_n = true
		) {
			_arr.push(_s.value);
			if (i && _arr.length === i) break;
		}
	} catch (err) {
		_d = true;
		_e = err;
	} finally {
		try {
			if (!_n && _i["return"] != null) _i["return"]();
		} finally {
			if (_d) throw _e;
		}
	}
	return _arr;
}

function _slicedToArray(arr, i) {
	if (Array.isArray(arr)) {
		return arr;
	} else if (Symbol.iterator in Object(arr)) {
		return _sliceIterator(arr, i);
	} else {
		throw new TypeError("Invalid attempt to destructure non-iterable instance");
	}
}

function initStepNames(base) {
	var range = base
		.map(function(e) {
			return e.split("-");
		})
		.map(function(_ref) {
			var _ref2 = _slicedToArray(_ref, 2),
				s = _ref2[0],
				e = _ref2[1];

			var len = e.charCodeAt() - s.charCodeAt();
			return new Array(len).fill(s.charCodeAt()).map(function(e, i) {
				return e + i;
			});
		})
		.reduce(function(acc, e) {
			return acc.concat(e);
		}, []);
	var rangeLength = range.length;

	var fetCharFromRange = function fetCharFromRange(step) {
		return String.fromCharCode(range[step % rangeLength]);
	};

	function getChar(step) {
		if (step <= rangeLength) {
			return fetCharFromRange(step);
		} else {
			return getChar(Math.floor(step / rangeLength)) + fetCharFromRange(step);
		}
	}

	var state = {
		step: 0,

		next() {
			this.step++;
			return getChar(this.step);
		}
	};
	return function() {
		return state.next();
	};
}

module.exports = {
	initStepNames
};
